//
// This linker command file was created by Introl-CODE.
//

// Define the program startup code
import __start;		// Import the call to the program
set __entry = __main;	// The program entry point
import __main;
import __stackinit;
import __bssinit;
import __datainit;
import __interruptinit;
import __exithalt;

// Library modules used by this program
import __hc11e1;
set _H11OPTIONinit = 0x93;
set _H11INITinit = 0x01;
import __fastinit;
set _H11BAUDinit = 0x30;
set _H11SCCR1init = 0x00;
set _H11SCCR2init = 0x0C;
set _ACIA = 0x9800;
set _ACIAreset = 0x03;
set _ACIAinit = 0x16;
set CX_INBUF = 100;
set CX_OUTBUF = 100;
import __serialio;

// Definitions of processor vectors
import __vectors;	// Import the vector table
set __vecD6 = __exit;	// SCI Serial System
set __vecD8 = __exit;	// SPI Serial Transfer Complete
set __vecDA = __exit;	// Pulse Accumulator Input Edge
set __vecDC = __exit;	// Pulse Accumulator Overflow
set __vecDE = tofHandler;	// Timer Overflow
set __vecE0 = toc5Handler;	// Timer Output Compare 5/Input Capture 4
set __vecE2 = __exit;	// Timer Output Compare 4
set __vecE4 = __exit;	// Timer Output Compare 3
set __vecE6 = __exit;	// Timer Output Compare 2
set __vecE8 = toc1Handler;	// Timer Output Compare 1
set __vecEA = tic3Handler;	// Timer Input Capture 3
set __vecEC = tic2Handler;	// Timer Input Capture 2
set __vecEE = __exit;	// Timer Input Capture 1
set __vecF0 = __exit;	// Real Time Interrupt
set __vecF2 = __exit;	// IRQ (External Pin or Parallel I/O)
set __vecF4 = __exit;	// XIRQ
set __vecF6 = __exit;	// SWI
set __vecF8 = __exit;	// Illegal Opcode Trap
set __vecFA = __exit;	// COP Failure (Reset)
set __vecFC = __exit;	// COP Clock Monitor Fail (Reset)
set __vecFE = __start;	// Reset
set __VECNUM = 21;

// Program memory groups
group BASE ram bss origin 0x0000 maxsize 0x01FF-0x0000;
    section .base;
    
    section .bss comms;
    section .data data copiedfrom .init;
    section .retm comm;
    section .heap expand minsize 0;
    section .stack minsize 0;
group BASE;

set __BASEstart = 0x0000;
set __BASEend = 0x01FF;
set __BASEsize = 0x01FF-0x0000;

group IO io bss origin 0x1000 maxsize 0x2000-0x1000;
    section .chip;
group IO;

set __IOstart = 0x1000;
set __IOend = 0x2000;
set __IOsize = 0x2000-0x1000;

group ROM rom origin 0x8000 maxsize 0x10000-0x8000;
    section .start0 text;
    section .start1 text;
    section .start2 text;
    section .start3 text;
    section .start4 text;
    section .start5 text;
    section .start6 text;
    section .start7 text;
    section .start8 text;
    section .start9 text;
    section .startX text;
    section .startZ text;
    
    section T2 text = .text;
    section C2 data = .const .strings;
    
    section .init;
    
    section .vectors data origin 0xFFD6;
group ROM;

set __ROMstart = 0x8000;
set __ROMend = 0x10000;
set __ROMsize = 0x10000-0x8000;


// Link time variable definitions
set __ramstart = startof(.bss);
set __ramend = endof(.bss);
set __heapstart = startof(.heap);
set __heapend = endof(.heap);
set __stackstart = startof(.stack);
set __stackend = endof(.stack);
set __initstart = startof(.init);
set __initend = endof(.init);
set __datastart = startof(.data);
set __dataend = endof(.data);
set __fastend = endof(.start1);
set __chipstart = startof(.chip);

readline;	// Read files from the command line

// Load libraries
'F:/Introl/lib/libgen.a11'

end;
