#include <hc11e1.h>
#include <string.h>
#include "display.h"

void dispPause(void)
{
 int i;
 for(i=0;i<=100;i++);
}

void dispPutIns(int d, int ins)
{
 if(d==lcdSm)  lcdSm_ctl=ins;
 if(d==lcdLg1) lcdLg1_ctl=ins;
 if(d==lcdLg2) lcdLg2_ctl=ins;
 dispPause();
}

void dispPutChar(int d, unsigned char ch)
{
 if(d==lcdSm)  lcdSm_dat=ch;
 if(d==lcdLg1) lcdLg1_dat=ch;
 if(d==lcdLg2) lcdLg2_dat=ch;
 dispPause();
}

void dispPutStr(int d, char Str[])
{
 unsigned int i;
 for (i = 0; i < strlen(Str); i++)
 dispPutChar(d,Str[i]);
}

void dispInitDisplay(int d)
{
 dispPutIns(d,Set_Function + Data_Length_8);
 dispPutIns(d,Set_Function + Data_Length_8);
 dispPutIns(d,Set_Function + Data_Length_8);
 dispPutIns(d,Set_Function + Data_Length_8 + Two_Display_Lines + Font_5x7);
 dispPutIns(d,Set_Display + Display_Off + Cursor_Off + Blink_Off);
 dispPutIns(d,Clear_Display);
 dispPutIns(d,Set_Entry_Mode + Increment_Address + Shift_Display_Off);
 dispPutIns(d,Set_Display + Display_On + Cursor_Off + Blink_Off);
}

void dispGotoXY(int d, int x, int y)
{
 if(y==1) { dispPutIns(d,Set_DDRAM_Address+x); }
 if(y==2) { dispPutIns(d,Set_DDRAM_Address+Line2_Offset+x); }
}

void dispPutCharXY(int d, int x, int y, char ch)
{
 dispGotoXY(d,x,y);
 dispPutChar(d,ch);
}

void dispPutStrXY(int d, int x, int y, char str[])
{
 dispGotoXY(d,x,y);
 dispPutStr(d,str);
}

void dispInit(void)
{
 dispInitDisplay(lcdSm);
 dispInitDisplay(lcdLg1);
 dispInitDisplay(lcdLg2);
}
